---
title: ShadowRoot.mode
slug: Web/API/ShadowRoot/mode
tags:
  - API
  - Property
  - Reference
  - ShadowRoot
  - mode
  - shadow dom
---
<div>{{APIRef("Shadow DOM")}}</div>

<p>The <strong><code>mode</code></strong> property of the {{domxref("ShadowRoot")}} specifies its mode — either <code>open</code> or <code>closed</code>. This defines whether or not the shadow root's internal features are accessible from JavaScript.</p>

<p>When the <code>mode</code> of a shadow root is "<code>closed</code>", the shadow root’s implementation internals are inaccessible and unchangeable from JavaScript—in the same way the implementation internals of, for example, the {{HTMLElement("video")}} element are inaccessible and unchangeable from JavaScript.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>mode</em> = <em>shadowRoot</em>.mode</pre>

<h3 id="Value">Value</h3>

<p>A value defined in the <code><a href="https://dom.spec.whatwg.org/#enumdef-shadowrootmode">ShadowRootMode</a></code> enum — either <code>open</code> or <code>closed</code>.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">let customElem = document.querySelector('my-shadow-dom-element');
let shadow = customElem.shadowRoot;

// Another way to check whether the shadow root is open; it will return null if not
if(shadow) {
  // If it is open, close it to stop people stealing our secrets!
  shadow.mode = 'closed';
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('DOM WHATWG','#dom-shadowroot-mode','ShadowRoot.mode')}}</td>
			<td>{{Spec2('DOM WHATWG')}}</td>
			<td> </td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ShadowRoot.mode")}}</p>
